from wxPython.wx import *
from pyTTS import *
import os

ID_ABOUT=101
ID_BUTTON1=110
ID_EXIT=200

class frame1(wxFrame):
    def __init__(self,parent,id,title):
        self.dirname = ''
        wxFrame.__init__(self,parent,-4, title, size = (400,450),style=wxDEFAULT_FRAME_STYLE|
                                        wxNO_FULL_REPAINT_ON_RESIZE)
        self.CreateStatusBar() # A Statusbar in the bottom of the window 
        # Setting up the menu. 
        filemenu= wxMenu()
        filemenu.Append(ID_ABOUT, "&About"," Information about this program")
        filemenu.AppendSeparator()
        filemenu.Append(ID_EXIT,"E&xit"," Terminate the program")
        # Creating the menubar. 
        menuBar = wxMenuBar()
        menuBar.Append(filemenu,"&File") # Adding the "filemenu" to the MenuBar 
        self.SetMenuBar(menuBar)  # Adding the MenuBar to the Frame content. 
        EVT_MENU(self, ID_ABOUT, self.OnAbout)
        EVT_MENU(self, ID_EXIT, self.OnExit)
        
        #Layout sizers
        self.SetAutoLayout(1)
        self.Show(1)
	
	self.speech = pyTTS()
	
	#set up a better voice
	self.voices = self.speech.GetVoices()
	self.speech.SetVoice(self.voices['MSSam'])

        # the edit control - one line version.
        #self.lblname = wxStaticText(self, -1, "Wrong :",wxPoint(20,250))
        self.editname = wxTextCtrl(self, 20, "", wxPoint(50, 270), wxSize(100, -1),wxTE_READONLY)
	self.editname2 = wxTextCtrl(self, 21, "", wxPoint(50, 300), wxSize(300, -1),wxTE_READONLY)
	self.editname3 = wxTextCtrl(self, 22, "", wxPoint(50, 240), wxSize(50, -1),wxTE_READONLY)
        
        # A multiline TextCtrl
        self.logger = wxTextCtrl(self,5, "",wxPoint(20,20), wxSize(200,150),wxTE_MULTILINE)
	EVT_TEXT(self.logger, 5, self.EvtText)
        EVT_CHAR(self.logger, self.EvtChar)
        
        # A button
        self.button =wxButton(self, 13, "Read", wxPoint(250, 150))
        EVT_BUTTON(self, 13, self.OnRead)

	#Buffers to hold recent text
	#self.lastChar = ''
	self.lastWord = ''
	self.lastSentence = ''
	self.currWord = ''
	self.currSentence = ''

    def OnAbout(self,e):
        d= wxMessageDialog( self, " Pronunciation Utility for BATS \n"
                            " by Doug Daniell","About this Program", wxOK)
                            # Create a message dialog box 
        d.ShowModal() # Shows it 
        d.Destroy() # finally destroy it when finished. 

    def OnExit(self,e):
        self.Close(true)  # Close the frame.
    def EvtText(self,e):
	self.logger.SetValue(e.GetString())
    def EvtChar(self,e):
        if e.GetKeyCode() == 8:
            range = self.logger.GetSelection()
            if range[0] == range[1]:
                self.logger.Remove(range[1]-1,range[1])
            else:
                self.logger.Remove(range[0],range[1])
        else:
            #Read in the character
            char = chr(e.GetKeyCode())
            self.editname3.SetValue(char)
            #self.speech.Speak(char, tts_async)
            if char == ' ':# or ',':
                self.lastWord = self.currWord
                self.editname.SetValue(self.lastWord)
                self.currSentence = self.currSentence + char
                self.currWord = ''
                self.speech.Speak(self.lastWord, tts_async)
            elif char == '.':# or '!' or '?':
                self.lastWord = self.currWord
                self.currWord = ''
                self.speech.Speak(self.lastWord, tts_async)
                self.editname.SetValue(self.lastWord)
                self.currSentence = self.currSentence + char
                self.lastSentence = self.currSentence
                self.editname2.SetValue(self.lastSentence)
                self.currSentence = ''
            else:
                self.currSentence = self.currSentence + char
                self.currWord = self.currWord + char
            
            self.logger.AppendText(char)
    def OnRead(self, event):
	self.speech.Speak(self.logger.GetValue(), tts_async)
    

app = wxPySimpleApp()
frame = frame1(None,-1,"Morse Code Utility")
frame.Show(1)
app.MainLoop()
